Como faço para reiniciar o sphinx quando reinicio meu servidor Ubuntu?

12

Eu criei e instalei a pesquisa do sphinx no meu servidor Ubuntu 9.04.

Como faço o daemon sphinx iniciar automaticamente quando reinicializo?

    
por 4 revs, 3 users 67%anon 17.09.2009 / 09:23

9 respostas

13

Eu não conheço a Esfinge, mas aqui está a abordagem básica. Crie um arquivo /etc/init.d/searchd com o seguinte conteúdo (também há este script , mas você provavelmente precisará ajustar um pouco):

#!/bin/bash

case "${1:-''}" in
  'start')
        # put the command to start sphinx
        # i.e., /usr/bin/searchd start or /usr/bin/searchd --daemon or whatever the command is
        ;;
  'stop')
        # stop command here
        ;;
  'restart')
        # restart command here
        ;;
  *)
        echo "Usage: $SELF start|stop|restart"
        exit 1
        ;;
esac

Em seguida, execute o seguinte:

$ sudo update-rc.d searchd defaults

Para controlar o serviço manualmente:

$ sudo /etc/init.d/searchd <start|stop|restart>
    
por 15.05.2009 / 19:14
1

Implementamos o Sphinx para um cliente em sistemas Debian e usamos o Runit para gerenciar os processos. Nós não tivemos que escrever um script de init especial, e já que estávamos usando o Runit em outras plataformas (CentOS / RHEL principalmente) era perfeitamente portátil.

    
por 01.06.2009 / 07:32
1

A versão da sphinx que é empacotada para o Ubuntu no momento da escrita (0.99) tem o script de inicialização abaixo.

Eu o reutilizei para o beta 2.0.1 que eu compilei a partir do código fonte, apenas alterando a linha DAEMON=/usr/local/.. e funciona para mim.

#! /bin/sh
#
#       Written by Miquel van Smoorenburg <[email protected]>.
#       Modified for Debian
#       by Ian Murdock <[email protected]>.
#               Further changes by Javier Fernandez-Sanguino <[email protected]>
#               Modified for sphinx by Radu Spineanu <[email protected]>
#
#

### BEGIN INIT INFO
# Provides:          sphinxsearch
# Required-Start:    $local_fs $remote_fs $syslog $network $time
# Required-Stop:     $local_fs $remote_fs $syslog $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Fast standalone full-text SQL search engine
### END INIT INFO


PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/sphinx/bin/searchd
NAME=sphinxsearch
DESC=sphinxsearch

test -x $DAEMON || exit 0

LOGDIR=/var/log/sphinxsearch
PIDFILE=/var/run/searchd.pid
DODTIME=1                   # Time to wait for the server to die, in seconds
                            # If this value is set too low you might not
                            # let some servers to die gracefully and
                            # 'restart' will not work

# Include sphinxsearch defaults if available
if [ -f /etc/default/sphinxsearch ] ; then
    . /etc/default/sphinxsearch
fi

if [ "$START" != "yes" ]; then
  echo "To enable $NAME, edit /etc/default/sphinxsearch and set START=yes"
  exit 0
fi


set -e

running_pid()
{
    # Check if a given process pid's cmdline matches a given name
    pid=$1
    name=$2
    [ -z "$pid" ] && return 1
    [ ! -d /proc/$pid ] &&  return 1
    cmd='cat /proc/$pid/cmdline | tr "
#! /bin/sh
#
#       Written by Miquel van Smoorenburg <[email protected]>.
#       Modified for Debian
#       by Ian Murdock <[email protected]>.
#               Further changes by Javier Fernandez-Sanguino <[email protected]>
#               Modified for sphinx by Radu Spineanu <[email protected]>
#
#

### BEGIN INIT INFO
# Provides:          sphinxsearch
# Required-Start:    $local_fs $remote_fs $syslog $network $time
# Required-Stop:     $local_fs $remote_fs $syslog $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Fast standalone full-text SQL search engine
### END INIT INFO


PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/sphinx/bin/searchd
NAME=sphinxsearch
DESC=sphinxsearch

test -x $DAEMON || exit 0

LOGDIR=/var/log/sphinxsearch
PIDFILE=/var/run/searchd.pid
DODTIME=1                   # Time to wait for the server to die, in seconds
                            # If this value is set too low you might not
                            # let some servers to die gracefully and
                            # 'restart' will not work

# Include sphinxsearch defaults if available
if [ -f /etc/default/sphinxsearch ] ; then
    . /etc/default/sphinxsearch
fi

if [ "$START" != "yes" ]; then
  echo "To enable $NAME, edit /etc/default/sphinxsearch and set START=yes"
  exit 0
fi


set -e

running_pid()
{
    # Check if a given process pid's cmdline matches a given name
    pid=$1
    name=$2
    [ -z "$pid" ] && return 1
    [ ! -d /proc/$pid ] &&  return 1
    cmd='cat /proc/$pid/cmdline | tr "%pre%0" "\n"|head -n 1 |cut -d : -f 1'
    # Is this the expected child?
    [ "$cmd" != "$name" ] &&  return 1
    return 0
}

running()
{
# Check if the process is running looking at /proc
# (works for all users)

    # No pidfile, probably no daemon present
    [ ! -f "$PIDFILE" ] && return 1
    # Obtain the pid and check it against the binary name
    pid='cat $PIDFILE'
    running_pid $pid $DAEMON || return 1
    return 0
}

force_stop() {
# Forcefully kill the process
    [ ! -f "$PIDFILE" ] && return
    if running ; then
        kill -15 $pid
        # Is it really dead?
        [ -n "$DODTIME" ] && sleep "$DODTIME"s
        if running ; then
            kill -9 $pid
            [ -n "$DODTIME" ] && sleep "$DODTIME"s
            if running ; then
                echo "Cannot kill $LABEL (pid=$pid)!"
                exit 1
            fi
        fi
    fi
    rm -f $PIDFILE
    return 0
}

case "$1" in
  start)
        echo -n "Starting $DESC: "

        # Check if we have the configuration file
        if [ ! -f /etc/sphinxsearch/sphinx.conf ]; then
            echo "Please create an /etc/sphinxsearch/sphinx.conf configuration file."
            echo "Templates are in the /etc/sphinxsearch/ directory."
            exit 0
        fi

        start-stop-daemon --start --exec ${DAEMON}
        if running ; then
            echo "$NAME."
        else
            echo " ERROR."
        fi
        ;;
  stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \
            --exec $DAEMON
        echo "$NAME."
        ;;
  force-stop)
        echo -n "Forcefully stopping $DESC: "
        force_stop
        if ! running ; then
            echo "$NAME."
        else
            echo " ERROR."
        fi
        ;;
  restart)
    echo -n "Restarting $DESC: "
        start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \
            --exec $DAEMON
        [ -n "$DODTIME" ] && sleep $DODTIME
        start-stop-daemon --start --exec ${DAEMON}
        echo "$NAME."
        ;;

  status)
    echo -n "$LABEL is "
    if running ;  then
        echo "running"
    else
        echo " not running."
        exit 1
    fi
    ;;
  *)
    N=/etc/init.d/$NAME
    # echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
    echo "Usage: $N {start|stop|restart|force-reload|status|force-stop}" >&2
    exit 1
    ;;
esac

exit 0
0" "\n"|head -n 1 |cut -d : -f 1' # Is this the expected child? [ "$cmd" != "$name" ] && return 1 return 0 } running() { # Check if the process is running looking at /proc # (works for all users) # No pidfile, probably no daemon present [ ! -f "$PIDFILE" ] && return 1 # Obtain the pid and check it against the binary name pid='cat $PIDFILE' running_pid $pid $DAEMON || return 1 return 0 } force_stop() { # Forcefully kill the process [ ! -f "$PIDFILE" ] && return if running ; then kill -15 $pid # Is it really dead? [ -n "$DODTIME" ] && sleep "$DODTIME"s if running ; then kill -9 $pid [ -n "$DODTIME" ] && sleep "$DODTIME"s if running ; then echo "Cannot kill $LABEL (pid=$pid)!" exit 1 fi fi fi rm -f $PIDFILE return 0 } case "$1" in start) echo -n "Starting $DESC: " # Check if we have the configuration file if [ ! -f /etc/sphinxsearch/sphinx.conf ]; then echo "Please create an /etc/sphinxsearch/sphinx.conf configuration file." echo "Templates are in the /etc/sphinxsearch/ directory." exit 0 fi start-stop-daemon --start --exec ${DAEMON} if running ; then echo "$NAME." else echo " ERROR." fi ;; stop) echo -n "Stopping $DESC: " start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \ --exec $DAEMON echo "$NAME." ;; force-stop) echo -n "Forcefully stopping $DESC: " force_stop if ! running ; then echo "$NAME." else echo " ERROR." fi ;; restart) echo -n "Restarting $DESC: " start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \ --exec $DAEMON [ -n "$DODTIME" ] && sleep $DODTIME start-stop-daemon --start --exec ${DAEMON} echo "$NAME." ;; status) echo -n "$LABEL is " if running ; then echo "running" else echo " not running." exit 1 fi ;; *) N=/etc/init.d/$NAME # echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2 echo "Usage: $N {start|stop|restart|force-reload|status|force-stop}" >&2 exit 1 ;; esac exit 0
    
por 04.10.2011 / 17:49
0

Eu realmente não sei esfinge, mas a julgar pelo manual on-line, você precisa ter um script de inicialização para executar o daemon. Em geral, isso é feito criando uma entrada em /etc/init.d e vinculando-a ao diretório /etc/rcX.d apropriado. Verifique o arquivo README em /etc/init.d para detalhes.

Se nada mais, algo assim é a resposta rápida e suja:

$ cat > /etc/init.d/sphinx
cd /usr/local/sphinx/etc
/usr/local/sphinx/bin/searchd
^D
$ ln -s /etc/init.d/sphinx /etc/init.d/rc3.d/S99sphinx
    
por 15.05.2009 / 16:06
0

Crie um arquivo de script curto (bash, talvez) que tenha o equivalente à seguinte linha:

/ caminho / para / esfinge / instalação / searchd --config /path/to/sphinx/config/sphinx.conf &

Em seguida, mova o script para /etc/init.d como root e chmod o script ("chmod + x myscript.sh")

    
por 15.05.2009 / 16:06
0

Adicione um script de reinicialização ao diretório /etc/init.d.

    
por 15.05.2009 / 16:12
0

Eu sugeriria uma solução ainda mais simples:

Basta adicionar / usr / bin / searchd a /etc/rc.local antes da linha que diz exit 0

    
por 15.05.2009 / 16:16
0

Se você usar a sphinx em seu aplicativo de trilhos, é uma maneira fácil de gerenciar isso com o sempre que a gema .

Ryan Bates fez um ótimo screencast sobre isso. Este site não me deixa colocar mais de um link aqui, mas eu recomendo.

    
por 16.09.2009 / 14:22
0

Veja este post no fórum: link

Basicamente, você pode adicionar uma tarefa cron que iniciará o Sphinx na reinicialização, executando isso a partir da linha de comando:

crontab -e

Adicione o seguinte:

@reboot searchd --config /path/to/config.conf

    
por 04.01.2010 / 23:27